' Fig. 5.17: Box.vb
' Class can be used to draw a square of a specified length, using
' a specified fill character.
Public Class Box
   Private sideValue As Integer ' length of side of square
   Private fillCharacterValue As String ' character used to draw square

   ' property provides access to side length of box
   Public Property Side() As Integer
      Get
         Return sideValue ' return side length
      End Get

      Set(ByVal value As Integer)
         sideValue = value ' modify side length
      End Set
   End Property ' Side

   ' property provides access to fill character for drawing box
   Public Property FillCharacter() As String
      Get
         Return fillCharacterValue ' return fill character
      End Get

      Set(ByVal value As String)
         fillCharacterValue = value ' modify fill character
      End Set
   End Property ' FillCharacter

   ' display box
   Public Sub Display()
      Dim row As Integer ' current row
      Dim column As Integer ' current column

      If Side <= 20 Then ' if true, then print the box
         row = 1

         ' this While is nested inside the If in lines 35-55  
         While row <= Side ' controls row being printed
            column = 1 ' prepare to print first character in the row

            ' this loop prints one row of the square
            ' and is nested inside the While in lines 39-52
            While column <= Side
               ' print fill character and a space
               Console.Write(FillCharacter & " ")
               column += 1 ' increment column
            End While

            Console.WriteLine() ' position cursor to next line
            row += 1 ' increment row
         End While
      Else ' condition (Side <= 20) is false
         Console.WriteLine("Side too large")
      End If
   End Sub ' Display
End Class ' Box


' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************