' Fig. 7.5: GradeBook.vb
' Definition of class GradeBook that finds the maximum of three grades.
Public Class GradeBook
   Private courseNameValue As String ' name of course 
   Private maximumGrade As Integer ' maximum of three grades

   ' constructor initializes course name
   Public Sub New(ByVal name As String)
      CourseName = name ' initializes CourseName
      maximumGrade = 0 ' this value will be replaced by maximum grade
   End Sub ' New

   ' property that gets and sets the course name; the Set accessor
   ' ensures that the course name has at most 25 characters
   Public Property CourseName() As String
      Get ' retrieve courseNameValue
         Return courseNameValue
      End Get

      Set(ByVal value As String) ' set courseNameValue
         If value.Length <= 25 Then ' if value has 25 or fewer characters
            courseNameValue = value ' store the course name in the object
         Else ' if name has more than 25 characters
            ' set courseNameValue to first 25 characters of parameter name
            ' start at 0, length of 25
            courseNameValue = value.Substring(0, 25)

            Console.WriteLine( _
               "Course name (" & value & ") exceeds maximum length (25).")
            Console.WriteLine( _
               "Limiting course name to first 25 characters." & vbCrLf)
         End If
      End Set
   End Property ' CourseName

   ' display a welcome message to the GradeBook user
   Public Sub DisplayMessage()
      Console.WriteLine("Welcome to the grade book for " _
          & vbCrLf & CourseName & "!" & vbCrLf)
   End Sub ' DisplayMessage

   ' input three grades from user
   Public Sub InputGrades()
      Dim grade1 As Integer ' first grade entered by user
      Dim grade2 As Integer ' second grade entered by user
      Dim grade3 As Integer ' third grade entered by user

      Console.Write("Enter the first grade: ")
      grade1 = Console.ReadLine()
      Console.Write("Enter the second grade: ")
      grade2 = Console.ReadLine()
      Console.Write("Enter the third grade: ")
      grade3 = Console.ReadLine()

      ' store the maximum in maximumGrade
      maximumGrade = Maximum(grade1, grade2, grade3)
   End Sub ' InputGrades

   ' returns the maximum of its three integer parameters
   Function Maximum(ByVal x As Integer, ByVal y As Integer, _
      ByVal z As Integer) As Integer

      Dim maximumValue As Integer = x ' assume x is the largest to start

      ' determine whether y is greater than maximumValue
      If (y > maximumValue) Then
         maximumValue = y ' make y the new maximumValue
      End If

      ' determine whether z is greater than maximumValue
      If (z > maximumValue) Then
         maximumValue = z ' make z the new maximumValue
      End If

      Return maximumValue
   End Function ' Maximum

   ' display a report based on the grades entered by user 
   Public Sub DisplayGradeReport()
      ' output maximum of grades entered
      Console.WriteLine("Maximum of grades entered: " & maximumGrade)
   End Sub ' DisplayGradeReport
End Class ' GradeBook


' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************