' Fig. 8.11: PassArray.vb
' Passing arrays and individual array elements to methods.
Module PassArray
   Sub Main()
      Dim array1 As Integer() = New Integer() {1, 2, 3, 4, 5}

      Console.WriteLine("EFFECTS OF PASSING AN ENTIRE ARRAY " & _
         "BY REFERENCE:" & vbCrLf & vbCrLf & _
         "The values of the original array are:")

      ' display original elements of array1
      For i As Integer = 0 To array1.GetUpperBound(0)
         Console.Write("  " & array1(i))
      Next

      ModifyArray(array1) ' array is passed by reference
      Console.WriteLine(vbCrLf & "The values of the modified array are:")

      ' display modified elements of array1
      For i As Integer = 0 To array1.GetUpperBound(0)
         Console.Write("  " & array1(i))
      Next

      Console.WriteLine(vbCrLf & vbCrLf & _
         "EFFECTS OF PASSING AN ARRAY ELEMENT BY VALUE:" & _
         vbCrLf & vbCrLf & "array1(3) before ModifyElementByVal: " & _
         array1(3))

      ModifyElementByVal(array1(3)) ' array element passed by value
      Console.WriteLine("array1(3) after ModifyElementByVal: " & _
         array1(3))
      Console.WriteLine(vbCrLf & "EFFECTS OF PASSING AN " & _
           "ARRAY ELEMENT BY REFERENCE: " & vbCrLf & vbCrLf & _
           "array1(3) before ModifyElementByRef: " & array1(3))

      ModifyElementByRef(array1(3)) ' array element passed by reference
      Console.WriteLine("array1(3) after ModifyElementByRef: " & _
         array1(3))
   End Sub ' Main

   ' method modifies array it receives (note ByVal)
   Sub ModifyArray(ByVal arrayParameter As Integer())
      For j As Integer = 0 To arrayParameter.GetUpperBound(0)
         arrayParameter(j) *= 2 ' double the array element   
      Next
   End Sub ' ModifyArray

   ' method modifies integer passed to it
   ' original is not modified (note ByVal)
   Sub ModifyElementByVal(ByVal element As Integer)
      Console.WriteLine("Value received in ModifyElementByVal: " & _
         element)
      element *= 2 ' double the array element                        
      Console.WriteLine("Value calculated in ModifyElementByVal: " & _
         element)
   End Sub ' ModifyElementByVal

   ' method modifies integer passed to it
   ' original is modified (note ByRef)
   Sub ModifyElementByRef(ByRef element As Integer)
      Console.WriteLine("Value received in ModifyElementByRef: " & _
         element)
      element *= 2 ' double the array element                        
      Console.WriteLine("Value calculated in ModifyElementByRef: " & _
         element)
   End Sub ' ModifyElementByRef
End Module ' PassArray


' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************
