﻿' Fig. 11.15: PayableInterfaceTest.vb
' Testing interface IPayable.
Module PayableInterfaceTest
   Sub Main()
      ' create four-element IPayable array
      Dim payableObjects() As IPayable = New IPayable(3) {}

      ' populate array with objects that implement IPayable
      payableObjects(0) = New Invoice("01234", "seat", 2, 375)
      payableObjects(1) = New SalariedEmployee( _
         "John", "Smith", "111-11-1111", 800)
      payableObjects(2) = New Invoice("56789", "tire", 4, 79.95D)
      payableObjects(3) = New SalariedEmployee( _
         "Lisa", "Barnes", "888-88-8888", 1200)

      Console.WriteLine( _
         "Invoices and Employees processed polymorphically:" & vbCrLf)

      ' generically process each element in array payableObjects
      For Each currentPayable As IPayable In payableObjects
         ' output currentPayable and its appropriate payment amount
         Console.WriteLine(currentPayable.ToString() & vbCrLf & _
            String.Format("payment due: {0:C}", _
            currentPayable.GetPaymentAmount()) & vbCrLf)
      Next
   End Sub ' Main
End Module ' PayableInterfaceTest

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************