' Fig. 14.11: FrmDateTimePickerForm.vb
' Using a DateTimePicker to select a drop off date.
Public Class FrmDateTimePickerTest
   ' set DateTimePicker's MinDate and MaxDate properties
   Private Sub FrmDateTimePickerTest_Load(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles MyBase.Load
      ' user cannot select days before today
      dropOffDateTimePicker.MinDate = DateTime.Today

      ' user can select days up to one year from now
      dropOffDateTimePicker.MaxDate = DateTime.Today.AddYears(1)
   End Sub ' FrmDateTimePickerTest_Load

   ' display delivery date
   Private Sub dropOffDateTimePicker_ValueChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles dropOffDateTimePicker.ValueChanged

      Dim dropOffDate As DateTime = dropOffDateTimePicker.Value

      ' add an extra day when items are dropped off Friday-Sunday
      If dropOffDate.DayOfWeek = DayOfWeek.Friday Or _
         dropOffDate.DayOfWeek = DayOfWeek.Saturday Or _
         dropOffDate.DayOfWeek = DayOfWeek.Sunday Then
         ' estimate three days for delivery
         lblOutput.Text = dropOffDate.AddDays(3).ToLongDateString()
      Else ' otherwise estimate only two days for delivery
         lblOutput.Text = dropOffDate.AddDays(2).ToLongDateString()
      End If
   End Sub ' dateTimePickerDropOff_ValueChanged
End Class ' FrmDateTimePickerTest

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************
