' Fig. 15.6: Consumer.vb
' Consumer consumes ten integer values from the shared buffer.
Imports System.Threading

' class Consumer's Consume method controls a thread that
' loops ten times and reads a value from sharedLocation
Public Class Consumer
   Private sharedLocation As IBuffer
   Private randomSleepTime As Random

   ' constructor
   Public Sub New(ByVal sharedBuffer As IBuffer, ByVal random As Random)
      sharedLocation = sharedBuffer
      randomSleepTime = random
   End Sub ' New

   ' read sharedLocation's value ten times
   Public Sub Consume()
      Dim sum As Integer = 0

      ' sleep for random interval upto 3000 milliseconds then
      ' add sharedLocation's Buffer property value to sum
      For count As Integer = 1 To 10
         Thread.Sleep(randomSleepTime.Next(1, 3001))
         sum += sharedLocation.Buffer ' consume
      Next count

      Console.WriteLine(Thread.CurrentThread.Name & _
         " read values totaling: " & sum & "." & vbCrLf & _
         "Terminating " & Thread.CurrentThread.Name & ".")
   End Sub ' Consume
End Class ' Consumer

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************
