' Fig. 16.17: DeckForm.vb
' Simulating card shuffling and dealing.
Public Class frmDeck
   Private deck(51) As Card ' deck of 51 cards
   Private currentCard As Integer ' count which card was just dealt

   ' handles form at load time
   Private Sub frmDeck_Load(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles MyBase.Load

      Dim faces As String() = _
         {"Ace", "Deuce", "Three", "Four", "Five", "Six", "Seven", _
         "Eight", "Nine", "Ten", "Jack", "Queen", "King"}
      Dim suits As String() = {"Hearts", "Diamonds", "Clubs", "Spades"}

      currentCard = -1 ' no cards have been dealt

      ' initialize deck
      For i As Integer = 0 To deck.Length - 1
         deck(i) = New Card(faces(i Mod 13), suits(i \ 13))
      Next i
   End Sub ' frmDeck_Load

   ' deal a card
   Private Sub btnDeal_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnDeal.Click

      Dim dealt As Card = DealCard()

      ' if dealt card is Nothing, then no cards left
      ' player must shuffle cards
      If Not (dealt Is Nothing) Then
         lblDisplay.Text = dealt.ToString()
         lblStatus.Text = "Card #: " & currentCard
      Else
         lblDisplay.Text = "NO MORE CARDS TO DEAL"
         lblStatus.Text = "Shuffle cards to continue"
      End If
   End Sub ' btnDeal_Click

   ' shuffle cards
   Private Sub Shuffle()
      Dim randomNumber As New Random()
      Dim temporaryValue As Card

      currentCard = -1

      ' swap each card with randomly selected card (0-51)
      For i As Integer = 0 To deck.Length - 1
         Dim j As Integer = randomNumber.Next(52)

         ' swap cards
         temporaryValue = deck(i)
         deck(i) = deck(j)
         deck(j) = temporaryValue
      Next i

      btnDeal.Enabled = True ' shuffled deck can now deal cards
   End Sub ' Shuffle

   ' deal a card if the deck is not empty
   Private Function DealCard() As Card
      ' if there is a card to deal then deal it;
      ' otherwise, signal that cards need to be shuffled by
      ' disabling dealButton and returning Nothing
      If currentCard + 1 < deck.Length - 1 Then
         currentCard += 1 ' increment count
         Return deck(currentCard) ' return new card
      Else
         btnDeal.Enabled = False ' empty deck cannot deal cards
         Return Nothing ' do not return a card
      End If
   End Function ' DealCard

   ' handles btnShuffle Click
   Private Sub btnShuffle_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnShuffle.Click

      lblDisplay.Text = "SHUFFLING..."
      Shuffle()
      lblDisplay.Text = "DECK IS SHUFFLED"
   End Sub ' btnShuffle_Click
End Class ' frmDeck

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************