' Fig. 16.21: Validate.vb
' Validate user information using regular expressions.
Imports System.Text.RegularExpressions

Public Class frmValidate
   ' handles btnOk Click event
   Private Sub btnOk_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnOk.Click
      ' ensures no TextBoxes are empty
      If txtLastName.Text = "" Or txtFirstName.Text = "" Or _
         txtAddress.Text = "" Or txtCity.Text = "" Or _
         txtState.Text = "" Or txtZipCode.Text = "" Or _
         txtPhone.Text = "" Then
         ' display popup box
         MessageBox.Show("Please fill in all fields", "Error", _
            MessageBoxButtons.OK, MessageBoxIcon.Error)
         txtLastName.Focus() ' set focus to txtLastName
         Return
      End If

      ' if last name format invalid show message
      If Not Regex.Match(txtLastName.Text, _
         "^[A-Z][a-zA-Z]*$").Success Then
         ' last name was incorrect
         MessageBox.Show("Invalid last name", "Message", _
            MessageBoxButtons.OK, MessageBoxIcon.Error)
         txtLastName.Focus()
         Return
      End If

      ' if first name format invalid show message
      If Not Regex.Match(txtFirstName.Text, _
         "^[A-Z][a-zA-Z]*$").Success Then
         ' first name was incorrect
         MessageBox.Show("Invalid first name", "Message", _
            MessageBoxButtons.OK, MessageBoxIcon.Error)
         txtFirstName.Focus()
         Return
      End If

      ' if address format invalid show message
      If Not Regex.Match(txtAddress.Text, _
         "^[0-9]+\s+([a-zA-Z]+|[a-zA-Z]+\s[a-zA-Z]+)$").Success Then
         ' address was incorrect
         MessageBox.Show("Invalid address", "Message", _
            MessageBoxButtons.OK, MessageBoxIcon.Error)
         txtAddress.Focus()
         Return
      End If

      ' if city format invalid show message
      If Not Regex.Match(txtCity.Text, _
         "^([a-zA-Z]+|[a-zA-Z]+\s[a-zA-Z]+)$").Success Then
         ' city was incorrect
         MessageBox.Show("Invalid city", "Message", _
            MessageBoxButtons.OK, MessageBoxIcon.Error)
         txtCity.Focus()
         Return
      End If

      ' if state format invalid show message
      If Not Regex.Match(txtState.Text, _
         "^([a-zA-Z]+|[a-zA-Z]+\s[a-zA-Z]+)$").Success Then
         ' state was incorrect
         MessageBox.Show("Invalid state", "Message", _
            MessageBoxButtons.OK, MessageBoxIcon.Error)
         txtState.Focus()
         Return
      End If

      ' if zip code format invalid show message
      If Not Regex.Match(txtZipCode.Text, "^\d{5}$").Success Then
         ' zip was incorrect
         MessageBox.Show("Invalid zip code", "Message", _
            MessageBoxButtons.OK, MessageBoxIcon.Error)
         txtZipCode.Focus()
         Return
      End If

      ' if phone number format invalid show message
      If Not Regex.Match(txtPhone.Text, _
         "^[1-9]\d{2}-[1-9]\d{2}-\d{4}$").Success Then
         ' phone number was incorrect
         MessageBox.Show("Invalid phone number", "Message", _
            MessageBoxButtons.OK, MessageBoxIcon.Error)
         txtPhone.Focus()
         Return
      End If

      ' information is valid, signal user and exit application
      Me.Hide() ' hide main window while MessageBox displays
      MessageBox.Show("Thank You!", "Information Correct", _
         MessageBoxButtons.OK, MessageBoxIcon.Information)
      Application.Exit()
   End Sub ' btnOk_Click
End Class ' frmValidate


'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************