' Fig 17.6: FrmShowColors.vb
' Color value and alpha demonstration.
Public Class FrmShowColors
   ' color for back rectangle
   Private backgroundColor As Color = Color.Wheat

   ' color for front rectangle
   Private foregroundColor As Color = Color.FromArgb(100, 0, 0, 255)

   ' override Form's OnPaint method
   Protected Overrides Sub OnPaint(ByVal e As PaintEventArgs)
      Dim graphicsObject As Graphics = e.Graphics ' get graphics object

      ' create text brush
      Dim textBrush As New SolidBrush(Color.Black)

      ' create solid brush
      Dim brush As New SolidBrush(Color.White)

      ' draw white background
      graphicsObject.FillRectangle(brush, 4, 4, 275, 180)

      ' display name of backColor
      graphicsObject.DrawString( _
         BackColor.Name, Me.Font, textBrush, 40, 5)

      ' set brush color and display back rectangle
      brush.Color = backgroundColor
      graphicsObject.FillRectangle(brush, 45, 20, 150, 120)

      ' display Argb values of front color
      graphicsObject.DrawString("Alpha: " & foregroundColor.A & _
         " Red: " & foregroundColor.R & " Green: " & _
         foregroundColor.G & " Blue: " & foregroundColor.B, Me.Font, _
         textBrush, 55, 165)

      ' set brush color and display front rectangle
      brush.Color = foregroundColor
      graphicsObject.FillRectangle(brush, 65, 35, 170, 130)
   End Sub ' OnPaint

   ' change Form's background color
   Private Sub btnColorName_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnColorName.Click
      ' set backColor to color specified in text box
      backgroundColor = Color.FromName(txtColorName.Text)
      Invalidate() ' refresh Form
   End Sub ' btnColorName_Click

   ' change Form's foreground color
   Private Sub btnColorValue_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnColorValue.Click
      ' obtain new front color from text boxes
      foregroundColor = Color.FromArgb( _
         Convert.ToInt32(txtAlpha.Text), Convert.ToInt32(txtRed.Text), _
         Convert.ToInt32(txtGreen.Text), Convert.ToInt32(txtBlue.Text))
      Invalidate() ' refresh Form   
   End Sub ' btnColorValue_Click
End Class ' FrmShowColors

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************