' Fig. 17.20: FrmDrawPolygons.vb
' Demonstrating polygons.
Public Class FrmDrawPolygons
   ' contains list of polygon vertices
   Private points As New ArrayList()

   ' initialize default pen and brush
   Private pen As New Pen(Color.DarkBlue)
   Private brush As New SolidBrush(Color.DarkBlue)

   ' draw panel mouse down event handler
   Private Sub pnlDraw_MouseDown(ByVal sender As Object, _
      ByVal e As System.Windows.Forms.MouseEventArgs) _
      Handles pnlDraw.MouseDown
      ' add mouse position to vertex list
      points.Add(New Point(e.X, e.Y))
      pnlDraw.Invalidate() ' refresh panel
   End Sub ' FrmDrawPolygons_MouseDown

   ' draw panel Paint event handler
   Private Sub pnlDraw_Paint(ByVal sender As Object, _
      ByVal e As System.Windows.Forms.PaintEventArgs) _
      Handles pnlDraw.Paint
      ' get graphics object for panel
      Dim graphicsObject As Graphics = e.Graphics

      ' if arraylist has 2 or more points, display shape
      If points.Count > 1 Then
         ' get array for use in drawing functions
         Dim pointArray As Point() = _
            CType(points.ToArray(points(0).GetType()), Point())

         If radLineOption.Checked Then
            graphicsObject.DrawLines(pen, pointArray)
         ElseIf radPolygonOption.Checked Then
            graphicsObject.DrawPolygon(pen, pointArray)
         ElseIf radFilledPolygonOption.Checked Then
            graphicsObject.FillPolygon(brush, pointArray)
         End If
      End If
   End Sub ' pnlDraw_Paint

   ' clear all points in the polygon
   Private Sub btnClear_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnClear.Click
      points.Clear() ' remove points
      pnlDraw.Invalidate() ' refresh panel
   End Sub ' btnClear_Click

   ' change pen and brush colors
   Private Sub btnColor_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles btnColor.Click
      ' create new color dialog
      Dim dialogColor As New ColorDialog()

      ' show dialog and obtain result
      Dim result As DialogResult = dialogColor.ShowDialog()

      ' return if user cancels
      If result = Windows.Forms.DialogResult.Cancel Then
         Return
      End If

      pen.Color = dialogColor.Color ' set pen to color
      brush.Color = dialogColor.Color ' set brush
      pnlDraw.Invalidate() ' refresh panel
   End Sub ' btnColor_Click

   ' cause Paint event
   Private Sub radLineOption_CheckedChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles radLineOption.CheckedChanged

      pnlDraw.Invalidate() ' refresh panel
   End Sub ' radLineOption

   ' cause Paint event
   Private Sub radPolygonOption_CheckedChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles radPolygonOption.CheckedChanged

      pnlDraw.Invalidate() ' refresh panel
   End Sub ' radPolygonOption

   ' cause Paint event
   Private Sub radFilledPolygonOption_CheckedChanged( _
      ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles radFilledPolygonOption.CheckedChanged

      pnlDraw.Invalidate() ' refresh panel
   End Sub ' radFilledPolygonOption
End Class ' FrmDrawPolygons

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************
