' Fig. 17.25 : ChessPiece.cs
' Class that represents chess piece attributes.
Public Class ChessPiece
   ' define chess-piece type constants
   Public Enum Types
      KING
      QUEEN
      BISHOP
      KNIGHT
      ROOK
      PAWN
   End Enum ' Types

   Private currentType As Integer ' this object's type
   Private pieceImage As Bitmap ' this object's image

   ' default display location
   Private targetRectangle As New Rectangle(0, 0, 75, 75)

   ' constructor
   Public Sub New(ByVal type As Integer, ByVal xLocation As Integer, _
      ByVal yLocation As Integer, ByVal sourceImage As Bitmap)

      currentType = type ' set current type
      targetRectangle.X = xLocation ' set current x location
      targetRectangle.Y = yLocation ' set current y location

      ' obtain pieceImage from section of sourceImage
      pieceImage = sourceImage.Clone( _
         New Rectangle(type * 75, 0, 75, 75), _
         System.Drawing.Imaging.PixelFormat.DontCare)
   End Sub ' New

   ' draw chess piece
   Public Sub Draw(ByVal graphicsObject As Graphics)
      graphicsObject.DrawImage(pieceImage, targetRectangle)
   End Sub ' end method Draw

   ' obtain this piece's location rectangle
   Public Function GetBounds() As Rectangle
      Return targetRectangle
   End Function ' end method GetBounds

   ' set this piece's location
   Public Sub SetLocation( _
      ByVal xLocation As Integer, ByVal yLocation As Integer)

      targetRectangle.X = xLocation
      targetRectangle.Y = yLocation
   End Sub ' end method SetLocation
End Class ' ChessPiece

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************
