' Fig. 18.13: RecordSerializable.vb
' Serializable class that represents a data record.

<Serializable()> _
Public Class RecordSerializable
   Private accountValue As Integer
   Private firstNameValue As String
   Private lastNameValue As String
   Private balanceValue As Decimal

   ' default constructor sets members to default values
   Public Sub New()
      MyClass.New(0, "", "", 0D)
   End Sub ' New

   ' overloaded constructor sets members to parameter values
   Public Sub New(ByVal account As Integer, ByVal firstName As String, _
      ByVal lastName As String, ByVal balance As Decimal)

      account = account
      firstNameValue = firstName
      lastNameValue = lastName
      balanceValue = balance
   End Sub ' New

   ' property Account
   Public Property Account() As Integer
      Get
         Return accountValue
      End Get
      Set(ByVal value As Integer)
         accountValue = value
      End Set
   End Property ' Account

   ' property FirstName
   Public Property FirstName() As String
      Get
         Return firstNameValue
      End Get
      Set(ByVal value As String)
         firstNameValue = value
      End Set
   End Property ' FirstName

   ' property LastName
   Public Property LastName() As String
      Get
         Return lastNameValue
      End Get
      Set(ByVal value As String)
         lastNameValue = value
      End Set
   End Property ' LastName

   ' property Balance
   Public Property Balance() As Decimal
      Get
         Return balanceValue
      End Get
      Set(ByVal value As Decimal)
         balanceValue = value
      End Set
   End Property ' Balance
End Class ' RecordSerializable

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************