' Fig. 19.23: FrmXmlDom.vb
' Demonstrates DOM tree manipulation.
Imports System.Xml

Public Class FrmXmlDom
   Private tree As TreeNode ' TreeNode reference

   ' initialize instance variables
   Private Sub FrmXmlDom_Load(ByVal sender As Object, _
      ByVal e As EventArgs) Handles MyBase.Load
      ' create Xml ReaderSettings and
      ' set the IgnoreWhitespace property
      Dim settings As New XmlReaderSettings()
      settings.IgnoreWhitespace = True

      ' create XmlReader object
      Dim reader As XmlReader = XmlReader.Create("letter.xml", settings)
      tree = New TreeNode() ' instantiate TreeNode
      tree.Text = "letter.xml" ' assign name to TreeNode
      treeXml.Nodes.Add(tree) ' add TreeNode to TreeView control
      BuildTree(reader, tree) ' build node and tree hierarchy
   End Sub ' FrmXmlDom_Load

   ' construct TreeView based on DOM tree
   Private Sub BuildTree(ByVal reader As XmlReader, _
      ByVal treeNode As TreeNode)
      ' treeNode to add to existing tree
      Dim newNode As New TreeNode()

      While reader.Read()
         ' build tree based on node type
         Select Case reader.NodeType
            Case XmlNodeType.Text ' add Text node's value to tree
               newNode.Text = reader.Value
               treeNode.Nodes.Add(newNode)
            Case XmlNodeType.EndElement ' move up tree
               treeNode = treeNode.Parent
            Case XmlNodeType.Element ' add element name and traverse tree
               ' determine whether element contains information
               If Not reader.IsEmptyElement Then
                  newNode.Text = reader.Name ' assign node text
                  treeNode.Nodes.Add(newNode) ' add newNode as child 
                  treeNode = newNode ' set treeNode to last child
               Else ' do not traverse empty elements
                  ' assign NodeType string to newNode and add it to tree
                  newNode.Text = reader.NodeType.ToString()
                  treeNode.Nodes.Add(newNode)
               End If
            Case Else ' all other types, display node type
               newNode.Text = reader.NodeType.ToString()
               treeNode.Nodes.Add(newNode)
         End Select

         newNode = New TreeNode()
      End While

      ' update TreeView control
      treeXml.ExpandAll() ' expand tree nodes in TreeView
      treeXml.Refresh() ' force TreeView to update
   End Sub ' BuildTree
End Class ' FrmXmlDom

' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************