' Fig. 19.28: FrmValidationTest.vb
' Validating XML documents against schemas.
Imports System.Xml
Imports System.Xml.Schema ' contains XmlSchemaSet class

Public Class FrmValidationTest
   Private schemas As XmlSchemaSet ' schemas to validate against
   Private valid As Boolean = True ' validation result

   ' handle Validate Button Click event
   Private Sub btnValidate_Click(ByVal sender As Object, _
      ByVal e As EventArgs) Handles btnValidate.Click
      schemas = New XmlSchemaSet() ' create the XmlSchemaSet class

      ' add the schema to the collection
      schemas.Add("http://www.deitel.com/booklist", "book.xsd")

      ' set the validation settings
      Dim settings As New XmlReaderSettings()
      settings.ValidationType = ValidationType.Schema
      settings.Schemas = schemas
      AddHandler settings.ValidationEventHandler, _
         AddressOf ValidationError

      ' create the XmlReader object
      Dim reader As XmlReader = XmlReader.Create(cboFiles.Text, settings)

      ' parse the file
      While reader.Read()
         ' empty body
      End While

      If valid Then ' check validation result
         lblConsole.Text = "Document is valid"
      End If

      valid = True ' reset variable
      reader.Close() ' close reader stream 
   End Sub ' btnValidate_Click

   ' event handler for validation error
   Private Sub ValidationError(ByVal sender As Object, _
      ByVal arguments As ValidationEventArgs)
      lblConsole.Text = arguments.Message
      valid = False ' validation failed
   End Sub ' ValidationError
End Class ' FrmValidationTest


' **************************************************************************
' * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************