' Fig. 22.20: ReservationWebService.vb
' Airline reservation Web Service.Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols

<WebService(Namespace:="http://www.deitel.com/")> _
<WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1)> _
<Global.Microsoft.VisualBasic.CompilerServices.DesignerGenerated()> _
Public Class ReservationWebService
   Inherits System.Web.Services.WebService
   ' create TicketsDataSet object for caching data 
   ' from the Tickets database
   Private ticketsDataSet As New TicketsDataSet()

   ' create SeatsTableAdapter for interacting with the database
   Private seatsTableAdapter As _
      New TicketsDataSetTableAdapters.SeatsTableAdapter()

   ' checks database to determine whether matching seat is available
   <WebMethod(Description:="Method to reserve a seat.")> _
   Public Function Reserve(ByVal seatType As String, _
      ByVal classType As String) As Boolean
      ' fill TicketsDataSet.Seats with rows that represent untaken
      ' seats that match the specified seatType and classType
      seatsTableAdapter.FillByTypeAndClass( _
         ticketsDataSet.Seats, seatType, classType)

      ' if the number of seats returned is nonzero, 
      ' obtain the first matching seat number and mark it as taken
      If ticketsDataSet.Seats.Count <> 0 Then
         Dim seatNumber As String = ticketsDataSet.Seats(0).Number

         seatsTableAdapter.UpdateSeatAsTaken(seatNumber)
         Return True ' seat was reserved
      End If

      Return False ' no seat was reserved
   End Function ' Reserve
End Class ' ReservationWebService

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************
