' Fig. 24.24: TreeTest.vb
' This program tests class Tree.
Imports BinaryTreeLibrary2

' class TreeTest declaration
Module TreeTest
   ' test class Tree
   Sub Main()
      Dim integerArray As Integer() = {8, 2, 4, 3, 1, 7, 5, 6}
      Dim doubleArray As Double() = _
         {8.8, 2.2, 4.4, 3.3, 1.1, 7.7, 5.5, 6.6}
      Dim stringArray As String() = _
         {"eight", "two", "four", "three", "one", "seven", "five", "six"}

      ' create integer Tree
      Dim integerTree As New Tree()
      populateTree(integerArray, integerTree, "integerTree")
      traverseTree(integerTree, "integerTree")

      ' create double Tree
      Dim doubleTree As New Tree()
      populateTree(doubleArray, doubleTree, "doubleTree")
      traverseTree(doubleTree, "doubleTree")

      ' create string Tree
      Dim stringTree As New Tree()
      populateTree(stringArray, stringTree, "stringTree")
      traverseTree(stringTree, "stringTree")
   End Sub ' Main

   ' populate Tree with array elements
   Sub populateTree(ByVal array As Array, _
      ByVal tree As Tree, ByVal name As String)

      Console.WriteLine(vbCrLf & vbCrLf & _
         vbCrLf & "Inserting into " & name & ":")

      For Each data As IComparable In array
         Console.Write(Convert.ToString(data) & " ")
         tree.InsertNode(data)
      Next data
   End Sub ' populateTree

   ' insert perform traversals
   Sub traverseTree(ByVal tree As Tree, ByVal treeType As String)
      ' perform preorder traveral of tree
      Console.WriteLine(vbCrLf & vbCrLf & _
         "Preorder traversal of " & treeType)
      tree.PreorderTraversal()

      ' perform inorder traveral of tree
      Console.WriteLine(vbCrLf & vbCrLf & _
         "Inorder traversal of " & treeType)
      tree.InorderTraversal()

      ' perform postorder traveral of tree
      Console.WriteLine(vbCrLf & vbCrLf & _
         "Postorder traversal of " & treeType)
      tree.PostorderTraversal()
   End Sub ' traverseTree
End Module ' TreeTest


'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************