' Fig. 26.3: UsingArray.vb
' Array class Shared methods for common array manipulations.
Imports System.Collections

Module UsingArray
   Private integerValues As Integer() = {1, 2, 3, 4, 5, 6}
   Private doubleValues As Double() = {8.4, 9.3, 0.2, 7.9, 3.4}
   Private integerValuesCopy As Integer()

   Sub Main()
      ' defaults to zeroes
      integerValuesCopy = New Integer(integerValues.Length - 1) {}

      Console.WriteLine("Initial array values:" & vbCrLf)
      PrintArrays() ' output initial array contents

      ' sort doubleValues
      Array.Sort(doubleValues)

      ' copy integerValues into integerValuesCopy
      Array.Copy(integerValues, integerValuesCopy, integerValues.Length)

      Console.WriteLine(vbCrLf & _
         "Array values after Sort and Copy:" & vbCrLf)
      PrintArrays() ' output array contents
      Console.WriteLine()

      ' search for 5 in integerValues
      Dim result As Integer = Array.BinarySearch(integerValues, 5)

      If (result >= 0) Then
         Console.WriteLine("5 found at element {0} in integerValues", _
            result)
      Else
         Console.WriteLine("5 not found in integerValues")
      End If

      ' search for 8763 in integerValues
      result = Array.BinarySearch(integerValues, 8763)

      If (result >= 0) Then
         Console.WriteLine("8763 found at element {0} in integerValues", _
            result)
      Else
         Console.WriteLine("8763 not found in integerValues")
      End If
   End Sub ' Main

   ' output array content with enumerators
   Private Sub PrintArrays()
      Console.Write("doubleValues: ")

      ' iterate through the Double array with an enumerator
      Dim enumerator As IEnumerator = doubleValues.GetEnumerator()

      While (enumerator.MoveNext())
         Console.Write(enumerator.Current & " ")
      End While

      Console.Write(vbCrLf & "integerValues: ")

      ' iterate through the Integer array with an enumerator
      enumerator = integerValues.GetEnumerator()

      While (enumerator.MoveNext())
         Console.Write(enumerator.Current & " ")
      End While

      Console.Write(vbCrLf & "integerValuesCopy: ")

      ' iterate through the second Integer array with a For Each statement
      For Each element As Integer In integerValuesCopy
         Console.Write(element & " ")
      Next element

      Console.WriteLine()
   End Sub ' PrintArrays
End Module ' UsingArray


'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'**************************************************************************