' Fig. 26.5: ArrayListTest.vb
' Using class ArrayList.
Imports System.Collections

Module ArrayListTest
   Private colors As String() = _
      {"MAGENTA", "RED", "WHITE", "BLUE", "CYAN"}
   Private removeColors As String() = {"RED", "WHITE", "BLUE"}

   Sub Main()
      Dim list As New ArrayList(1) ' initial capacity of 1  

      ' add the elements of the colors array 
      ' to the ArrayList list
      For Each color As String In colors
         list.Add(color) ' add color to the ArrayList list       
      Next color

      ' add elements in the removeColors array to 
      ' the ArrayList removeList with the ArrayList constructor
      Dim removeList As New ArrayList(removeColors)

      Console.WriteLine("ArrayList: ")
      DisplayInformation(list) ' output the list

      ' remove from ArrayList list the colors in removeList
      RemoveColorNames(list, removeList)

      Console.WriteLine(vbCrLf & _
         "ArrayList after calling RemoveColors: ")
      DisplayInformation(list) ' output list contents
   End Sub ' Main

   ' displays information on the contents of an array list
   Private Sub DisplayInformation(ByVal arrayList As ArrayList)
      ' iterate through array list with a For Each statement
      For Each element As Object In arrayList
         Console.Write("{0} ", element) ' invokes ToString
      Next element

      ' display the size and capacity
      Console.WriteLine(vbCrLf & "Size = {0}; Capacity = {1}", _
         arrayList.Count, arrayList.Capacity)

      Dim index As Integer = arrayList.IndexOf("BLUE")

      If index <> -1 Then
         Console.WriteLine("The array list contains BLUE at index {0}.", _
            index)
      Else
         Console.WriteLine("The array list does not contain BLUE.")
      End If
   End Sub ' DisplayInformation

   ' remove colors specified in secondList from firstList
   Private Sub RemoveColorNames(ByVal firstList As ArrayList, _
      ByVal secondList As ArrayList)
      ' iterate through second ArrayList like an array
      For count As Integer = 0 To secondList.Count - 1
         firstList.Remove(secondList(count))
      Next count
   End Sub ' RemoveColors
End Module ' ArrayListTest

'**************************************************************************
'* (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
'* Pearson Education, Inc. All Rights Reserved.                           *
'*                                                                        *
'* DISCLAIMER: The authors and publisher of this book have used their     *
'* best efforts in preparing the book. These efforts include the          *
'* development, research, and testing of the theories and programs        *
'* to determine their effectiveness. The authors and publisher make       *
'* no warranty of any kind, expressed or implied, with regard to these    *
'* programs or to the documentation contained in these books. The authors *
'* and publisher shall not be liable in any event for incidental or       *
'* consequential damages in connection with, or arising out of, the       *
'* furnishing, performance, or use of these programs.                     *
'*************************************************************************/

